//=========================================================================
//  Copyright (c) Kitware, Inc.
//  All rights reserved.
//  See LICENSE.txt for details.
//
//  This software is distributed WITHOUT ANY WARRANTY; without even
//  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the above copyright notice for more information.
//=========================================================================
#ifndef __smtk_session_aeva_Registrar_h
#define __smtk_session_aeva_Registrar_h

#include "smtk/session/aeva/Exports.h"
#include "smtk/session/aeva/NameManager.h"

#include "smtk/attribute/Registrar.h"
#include "smtk/common/Managers.h"
#include "smtk/extension/vtk/geometry/Registrar.h"
#include "smtk/extension/vtk/operators/Registrar.h"
#include "smtk/model/Registrar.h"
#include "smtk/operation/Manager.h"
#include "smtk/operation/Registrar.h"
#include "smtk/resource/Manager.h"
#include "smtk/view/Manager.h"

namespace smtk
{
namespace session
{
namespace aeva
{

class SMTKAEVASESSION_EXPORT Registrar
{
public:
  using Dependencies = std::tuple<operation::Registrar,
    model::Registrar,
    attribute::Registrar,
    extension::vtk::operators::Registrar,
    extension::vtk::geometry::Registrar>;

  static void registerTo(const smtk::common::Managers::Ptr& managers);
  static void unregisterFrom(const smtk::common::Managers::Ptr& managers);

  static void registerTo(const smtk::operation::Manager::Ptr& operationManager);
  static void unregisterFrom(const smtk::operation::Manager::Ptr& operationManager);

  static void registerTo(const smtk::resource::Manager::Ptr& resourceManager);
  static void unregisterFrom(const smtk::resource::Manager::Ptr& resourceManager);

  static void registerTo(const smtk::view::Manager::Ptr& viewManager);
  static void unregisterFrom(const smtk::view::Manager::Ptr& viewManager);
};
}
}
}

#endif
